// GameTalkAPI.cpp : ش DLL ʱȭ ƾ մϴ.
//

#include "stdafx.h"
#include "GameTalkAPI.h"
#include "GameTalkAPIGlobal.h"

#include "Singleton.h"
#include "MessengerActor.h"
#include "NotificationProxy.h"

#if defined(WIN32) // PORTING
//#include "GtScopedLog.h"
#include "ITinyWindow.h"
#else
#include "IGTPoller.h"
#include "AudioWorkThread.h"
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////
// External API Function

bool __stdcall NeMessengerAPI::InitNeMessengerAPI(LPCWSTR strAPIVersion)
{
	//CGTLifeLog log(__FUNCTION__);
	
#if defined(WIN32)
	// NOTHING TO DO
#else	
	GTPollerAPI::CreateGTPoller( AudioWorkThread::GetInstance() );
#endif	
	
	//  ٸ 
	if(wcscmp(strAPIVersion, GT_API_VERSION) != 0)
	{
		//CGTNormLog log("GameTalkAPI Version Different!! %s <> %s", strAPIVersion, GT_API_VERSION);
		
		return false;
	}

	// ȯ漳  ʾҴٸ ʱȭ ʴ´!
	if(GT_GLOBAL->IsEnvironmentSettingOK() == false)
		return false;

#if defined(WIN32)
	RegisterTinyWindow(GT_GLOBAL->GetEnvironment().hInstance);
#endif
	
	CSingleton<CDefaultNotificationProxy>::Instance();
	
	GT_GLOBAL->Initialize();

	//NTALK_LOG->Initialize();

	//NTALK_LOG->Debug("[DLL] INIT MESSENGER API");

	return true;
}


bool __stdcall NeMessengerAPI::CleanNeMessengerAPI(void)
{
#if defined(WIN32)
	//CGTLifeLog log(__FUNCTION__);
#endif
	
	GT_GLOBAL->Finalize();

#if defined(WIN32)
	// ̻  ó  ϵ 
	UnregisterTinyWindow();
#endif
	
	CSingleton<CGameTalkAPIGlobal>::ForceToDelete();

	CSingleton<CDefaultNotificationProxy>::ForceToDelete();

#if defined(WIN32)
	// NOTHING TO DO
#else			
	GTPollerAPI::DeleteGTPoller();
#endif	
	return true;
}


bool __stdcall NeMessengerAPI::CreateMessengerActor(int nUserID, IGTMessengerActor **pValue)
{
//#if defined(WIN32)
//	//CGTLifeLog log(__FUNCTION__);
//#endif
	if(GT_GLOBAL->IsAvailableAPI() == false || pValue == NULL)
	{
		*pValue = NULL;
		return false;
	}

	// ̹ ִ üũ
	CMessengerActor * pActor = GT_GLOBAL->GetMessengerActor(nUserID);
	if(pActor != NULL)
	{
		if(pValue)
			*pValue = pActor;
		return true;
	}

	CMessengerActor *pMessengerActor = GT_GLOBAL->CreateMessengerActor(nUserID);

	if(pValue)
		*pValue = pMessengerActor;
	else
		return false;
	return true;
}


bool __stdcall NeMessengerAPI::DeleteMessengerActor(int nUserID)
{
//#if defined(WIN32)
//	//CGTLifeLog log(__FUNCTION__);
//#endif
	if(GT_GLOBAL->IsAvailableAPI() == false)
	{
		return false;
	}
	
	// ִ üũ
	CMessengerActor * pActor = GT_GLOBAL->GetMessengerActor(nUserID);
	if(pActor == NULL)
	{
		return false;
	}
	
	return GT_GLOBAL->DeleteMessengerActor(nUserID);
}


bool __stdcall NeMessengerAPI::GetMessengerActor(int nUserID, IGTMessengerActor **pValue)
{
	if(GT_GLOBAL->IsAvailableAPI() == false || pValue == NULL)
	{
		*pValue = NULL;
		return false;
	}

	// ִ üũ
	CMessengerActor * pActor = GT_GLOBAL->GetMessengerActor(nUserID);

	if(pActor == NULL)
	{
		if(pValue)
			*pValue = NULL;
		return false;
	}

	if(pValue)
		*pValue = pActor;
	return true;
}




//------------------------------------------------------------------------------------------------
//
// NeMessengerAPISetting 
//
//------------------------------------------------------------------------------------------------

bool __stdcall NeMessengerAPISetting::SetEnvironment(const GT_API_ENVIRONMENT_DATA &sEnv)
{
//#if defined(WIN32)
//	//CGTLifeLog log(__FUNCTION__);
//#endif
	GT_GLOBAL->SetEnvironment(sEnv);

	return true;
}


void __stdcall NeMessengerAPISetting::GetEnvironment(GT_API_ENVIRONMENT_DATA &sEnv)
{
	GT_GLOBAL->GetEnvironment().Convert(sEnv);
}


